Bug 1584 - provide system management software under free software licenses
: provide system management software under free software licenses
Status: RESOLVED FIXED
Product: Development platform
general
: unspecified
: N800 Maemo
: Medium enhancement with 15 votes (vote)
: 5.0-beta
Assigned To: Quim Gil
: dev-platform-general-bugs
:
:
:
:
  Show dependency tree
 
Reported: 2007-06-25 23:06 UTC by Robert Schuster
Modified: 2009-08-05 14:54 UTC (History)
8 users (show)

See Also:


Attachments


Note

You need to log in before you can comment on or make changes to this bug.


Description Robert Schuster (reporter) 2007-06-25 23:06:10 UTC
Several applications and libraries found on the N800 internet tablet/IT OS
2007.10 are distributed under restricted and non-free license terms according
to the Debian Free Software Guidelines, Open Source Definition and Free
Software definition.

I hereby politely ask for distributing those components under terms that are
acceptable to the above mentioned guidelines.

The applications of interest are:
from the initfs: activate_panel, bt-cal, cal-tool, fb-chaimage, text2screen,
wlan-cal, wlan-fw-update, retu-time, show_image, dsme, battest, bootstate,
dsmetool, dspctl, waitfordsme and the script linuxrc

the libraries of interest are:
libbmeic.so, libcal.so, libdsme.so, libppu.so, libactivitymonitor.so,
libcalmodule.so, libhwwd.so, libinactivity-blank.so, liblifeguard.so,
libperipheral.so, libprocesswd.so, libstartup.so, libstate.so,
libtemperature.so

There may be other software artifacts which are of interest for which I will
file separate bugreports if there is a need for them.

Rationale:
When Nokia/Maemo decided to use a variant of the GNU operating system and Linux
as its kernel for implementing the Internet Tablet OS they profited from a
wealth of knowledge and work invested in various software projects. With the
help of free software licensing they were allowed to create a unique software
environment which exactly implements the Maemo projects' goals. Maemo has
gained and still gains from those software projects because they are
independently developed further giving Maemo more possibilities in the future.

One of the key goals of the GNU project is to give its user's the freedom to
implement their own ideas. This goal is to be reached by writing free software
and sometimes (in the early days often) replacing proprietary software.

The non-free bits in the core infrastructure of the IT OS 2007 are a road block
for efforts to create free operating systems/distributions besides IT OS on the
N770/N800.

The reason for why it is helpful to have other operating system/distribution on
the N800 is simple: There are hundreds of GNU/Linux distributions out there.
Each one exists because there is a userbase that exactly likes their flavor of
GNU/Linux.

For the N770/N800 Internet Tablets there exists only one such distribution: The
Internet Tablet OS. With the sheer amount of GNU/Linux distributions for
desktops/workstations/servers/routers/PDAs on the one hand and the single OS
solution for the Internet Tablets on the other I doubt that it can handle all
the possible uses people have.

By releasing the above mentioned programs/libraries under free software
licenses people will be given the same possibilities the Maemo project had in
the first place.

Let us be free.
Comment 1 Quim Gil nokia 2007-06-26 09:35:21 UTC
Thank you for this very well formulated request. It will take some time to
satisfy it and it migjht even happen in a way that doesn't totally fulfill this
request. But let's agree on a couple of principles:

- Users should be able to install their customized maemo-based variants and
even other distros in the Nokia Internet Tablets.

- Hardware manufacturers should be able to deploy maemo-based variants in their
devices.

These are not priorities for us now. We want to keep focusing in maemo and the
IT OS running like a charm in the Nokia Internet Tablets. But we do want to
remove the obstacles depending on us that make the scenarios above unfeasible.

Releasing the mentioned components under a free software license would be
indeed a solution, but it might be pretty complicated and near to impossible to
provide this for all components in the short term. We will go piece by piece
trying to find the best solution in each case, surely with a high dose of
pragmatism.

Please be patient. To start with, July is around the corner. This means massive
holidays in Finland, comprising many of the people with capacity of decision
about the issues and software discussed here. We will make some little steps in
July and them we will start the internal work more seriously in August.

I can't promise any results, nor any deadline, but I'm picking this enhancement
request and I will push it forward (I had to do it anyway but you have provided
a very good starting point).
Comment 2 Robert Schuster (reporter) 2007-09-10 15:26:53 UTC
Thanks for this:
http://live.gnome.org/Hildon/HildonInputMethod

Looking forward to see more of the low-level stuff. :)
Comment 3 Quim Gil nokia 2007-09-22 00:41:58 UTC
You're welcome.  ;)

So, at the end this is a process that is done package by package, feature by
feature. We have our internal priorities and preferences based on many factors
i.e. IPR, investment made, state of the code and documentation, effort needed
to make it public... 

One important factor is real demand. Yes, we know that many people want to have
the platform open 100% but... I don't see this happening anytime soon,
specially not in one go. 

If you had to choose, say, 3 packages which ones would you choose. Having a
list of priorities would help setting a clearer agenda and going through the
list package by package. These priorities should be developer-centric to be
more efficient. I mean, opening platform components and opening applications
are quite different stories. Let's concentrate on the platform components here.
Comment 4 Ryan Abel maemo.org 2008-03-26 08:57:45 UTC
(In reply to comment #3)
> If you had to choose, say, 3 packages which ones would you choose.

Where do you want this, in new enhancement requests or here?

I believe bme/dsme is going to be at the top of most people's lists, as power
management is really the biggest hurdle for alternative Linux distributions
(johnx's Debian port, etc) on the NITs. DSP stuff is second, as sound is the
next major hurdle. Third there are a number of candidates, but, personally, I'd
like to see tablet-browser opened up (why did we move from the open browser-ui
to the closed tablet-browser again?), but that's an Application-level issue.
Comment 5 Nick Loeve 2008-03-26 14:42:24 UTC
(In reply to comment #4)
> (In reply to comment #3)
> > If you had to choose, say, 3 packages which ones would you choose.
> 
> Where do you want this, in new enhancement requests or here?
> 
> I believe bme/dsme is going to be at the top of most people's lists, as power
> management is really the biggest hurdle for alternative Linux distributions
> (johnx's Debian port, etc) on the NITs. 

Yes it tops my list
Comment 6 Karsten Br├Ąckelmann 2008-06-02 18:05:46 UTC
(In reply to comment #4)
> > If you had to choose, say, 3 packages which ones would you choose.
> 
> Where do you want this, in new enhancement requests or here?

Ryan, please file new, dedicated enhancement requests for specific packages. By
keeping them separate, each issue / package can be handled independently and
more efficient. Specific, fine-grained bug reports are better to deal with than
a huge list in a single bug.

Feel free make specific requests depend on this bug, treating it like a meta
bug.
Comment 7 Quim Gil nokia 2008-06-04 12:19:59 UTC
As discussed in several places lately, Nokia doesn't have the objective of
providing a 100% free OS. The system level is widely open but still there are
many exceptions.

The (pre)agreed steps eing defined as we speak in the maemo.org brainstorm and
collateral discussions are:

- https://wiki.maemo.org/Increasing_transparency aka a table explaining what is
open, what is closed and why.

- https://wiki.maemo.org/2010_Agenda#Openness.2C_openness.2C_openness and
specifically the part that says "The ability to strip a maemo-based OS down to
its base and build it up again differently". People CCed and voting to this bug
are invited to improve and expand the plans in those wiki pages.

These are the basic needs for anybody willing to build a 100% free maemo
variant or run a 100% free OS in the maemo compatoble devices.
Comment 8 Quim Gil nokia 2008-10-03 15:16:43 UTC
Hi, have a look at
http://flors.wordpress.com/2008/09/20/how-maemo-approaches-open-source/ and
http://flors.wordpress.com/2008/09/19/osim-world-maemo-devsesh-slides/ where
there is information about the open source approach Maemo is taking and the
last steps opensourcing components.

Also see to http://wiki.maemo.org/Why_the_closed_packages and
http://lists.maemo.org/pipermail//maemo-community/2008-October/001027.html .
Please list in the wiki page the closed components that you would really like
to see open.

It is a good time to review the licenses of our closed system components and
discuss free alternatives, but it is important to discuss the stuff that matter
to you most. Every component is a different discussion and taking all at the
same time is just pointless from a practical point of view. Thanks!
Comment 9 Quim Gil nokia 2008-10-04 19:09:52 UTC
btw

(In reply to comment #4)
> I believe bme/dsme is going to be at the top of most people's lists

It has been announced that dsme will be opened in Fremantle.
Comment 10 Ryan Abel maemo.org 2008-10-04 23:05:22 UTC
(In reply to comment #9)
> (In reply to comment #4)
> > I believe bme/dsme is going to be at the top of most people's lists
> 
> It has been announced that dsme will be opened in Fremantle.
> 

Fremantle or sometime in the 2-week period period after the Summit as was
announced?
Comment 11 Quim Gil nokia 2008-10-06 12:51:26 UTC
Let's say 2 weeks or so from now.  :) It's just a matter of the developer in
charge finding the time to polish a bit more the code before the first public
release.

By the way, now the components and pluguns related to dsme are listed at
http://wiki.maemo.org/Why_the_closed_packages
Comment 12 Quim Gil nokia 2008-10-07 13:06:10 UTC
(In reply to comment #4)
> I believe bme/dsme is going to be at the top of most people's lists

As explained at
http://wiki.maemo.org/Why_the_closed_packages#Specific_reasons_for_packages,
dsme covered many areas including power management, which is considered a
differentiation area by Nokia. The component has been redesigned and the
sensitive functionality has moved to mce, allowing to distribute dsme (soon)
with an open license together with related tools and plugins: bootstate,
dsmetool, waitfordsme, libdsme.so, libhwwd.so, liblifeguard.so,
libprocesswd.so, libstartup.so and libstate.so. Then libtemperature.so will be
replaced by another component consisting of several dsme open source plugins.
Finally, libcalmodule.so will be dropped.

> I'd like to see tablet-browser opened up

From the same wiki page:

tablet-browser-ui: At the beginning there was a proprietary browser. In Maemo
4.0 the Mozilla based browser came, with an open engine (MicroB) but still a
closed UI provided by tablet-browser. The main reason was the default rule to
have the Maemo applications UI closed for differentiation. The context in
mobile browsing has changed significantly and now there are better reasons to
offer also an open browser UI. This is the plan for Fremantle. 

The list is getting smaller...
Comment 13 Quim Gil nokia 2008-10-24 13:57:58 UTC
DSP related information provided at
http://wiki.maemo.org/Why_the_closed_packages#Specific_reasons_for_packages

PulseAudio and perhaps TI as well will help "clearing up" this area from
obstacles to open development.
Comment 14 Quim Gil nokia 2008-12-01 09:47:26 UTC
At this point I want to propose to resolve this bug in the way you prefer. A
lot of progress has been done even if not all the components you are listing
here have been opened yet.

It would be more fruitful to have requests for specific components so we can
discuss and resolve each one, setting the right priority from both sides. Now
this is just too big to digest in one go.
Comment 15 Andre Klapper maemo.org 2008-12-01 12:07:43 UTC
(In reply to comment #14)
> At this point I want to propose to resolve this bug in the way you prefer. A
> lot of progress has been done even if not all the components you are listing
> here have been opened yet.
> 
> It would be more fruitful to have requests for specific components so we can
> discuss and resolve each one, setting the right priority from both sides. Now
> this is just too big to digest in one go.

So this issue is mostly FIXED to me. If there's still software left that you
want to have open sourced, please file seperate bug reports explicitly naming
the package. Thanks!
Comment 16 Andre Klapper maemo.org 2009-04-28 15:33:47 UTC
Setting Target Milestone to Fremantle SDK beta.
Comment 17 t3st3r 2009-08-05 14:30:02 UTC
Fixed? Huh? And how about this issue?
http://www.nopcode.org/0xFFFF/?p=docu&q=bug-report

Are we expected to use (potentially unreliable) opensource flasher which is
using reverse-engineered data knowledge of file format (which could be
incomplete or partially incorrect) instead of vendor's specs on these formats?
I'm pretty sure flasher is a "system management software".
Comment 18 Andre Klapper maemo.org 2009-08-05 14:54:04 UTC
Flasher is not system management software as it does not run on the system.

t3st3r: Did you read comment 15? :)